/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VCoreVariableattrRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.JSONB;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreVariableattr extends TableImpl<VCoreVariableattrRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_variableattr</code>
     */
    public static final VCoreVariableattr V_CORE_VARIABLEATTR = new VCoreVariableattr();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreVariableattrRecord> getRecordType() {
        return VCoreVariableattrRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_variableattr.unique_name</code>.
     */
    public final TableField<VCoreVariableattrRecord, String> UNIQUE_NAME = createField(DSL.name("unique_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_variableattr.value</code>.
     */
    public final TableField<VCoreVariableattrRecord, JSONB> VALUE = createField(DSL.name("value"), SQLDataType.JSONB, this, "");

    /**
     * The column <code>common_dd.v_core_variableattr.key</code>.
     */
    public final TableField<VCoreVariableattrRecord, String> KEY = createField(DSL.name("key"), SQLDataType.CLOB, this, "");

    private VCoreVariableattr(Name alias, Table<VCoreVariableattrRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreVariableattr(Name alias, Table<VCoreVariableattrRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_variableattr" as  SELECT e.unique_name,
         va.value,
         vat.name AS key
        FROM ((common_dd.t_core_variableattr va
          LEFT JOIN common_dd.t_core_variableattrtype vat ON ((vat.pk = va.fk_variableattrtype)))
          LEFT JOIN common_dd.t_core_element_hierarchy e ON ((e.key_element = va.fk_variable)));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_variableattr</code> table
     * reference
     */
    public VCoreVariableattr(String alias) {
        this(DSL.name(alias), V_CORE_VARIABLEATTR);
    }

    /**
     * Create an aliased <code>common_dd.v_core_variableattr</code> table
     * reference
     */
    public VCoreVariableattr(Name alias) {
        this(alias, V_CORE_VARIABLEATTR);
    }

    /**
     * Create a <code>common_dd.v_core_variableattr</code> table reference
     */
    public VCoreVariableattr() {
        this(DSL.name("v_core_variableattr"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreVariableattr as(String alias) {
        return new VCoreVariableattr(DSL.name(alias), this);
    }

    @Override
    public VCoreVariableattr as(Name alias) {
        return new VCoreVariableattr(alias, this);
    }

    @Override
    public VCoreVariableattr as(Table<?> alias) {
        return new VCoreVariableattr(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreVariableattr rename(String name) {
        return new VCoreVariableattr(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreVariableattr rename(Name name) {
        return new VCoreVariableattr(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreVariableattr rename(Table<?> name) {
        return new VCoreVariableattr(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreVariableattr where(Condition condition) {
        return new VCoreVariableattr(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreVariableattr where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreVariableattr where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreVariableattr where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreVariableattr where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreVariableattr where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreVariableattr where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreVariableattr where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreVariableattr whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreVariableattr whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
